## arch-test 0.5

=== Makefile ===
ARCHS=amd64 x32 i386 \
	win32 win64 \
	mips mipsel mips64 mips64el \
	illumos-amd64 \
	kfreebsd-amd64 kfreebsd-i386 \
	powerpc ppc64 ppc64el powerpcspe \
	s390x \
	arm64 arm armel armhf \
	sh4 \
	m68k \
	sparc sparc64 \
	alpha
X86=x86_64-linux-gnu
MIPS=mips-linux-gnu
POWERPC=powerpc-linux-gnu
ARM=arm-linux-gnueabihf
SPARC=sparc64-linux-gnu
-include config
all: $(ARCHS:%=arch-test-%)

clean:
	rm -f *.o arch-test-* core *.core

distclean: clean
	rm -f config

DESTDIR=
PREFIX=/usr/local
install: all
	mkdir -p $(DESTDIR)$(PREFIX)/lib/arch-test/
	sed -e "s|^HELPERS.*|HELPERS=$(PREFIX)/lib/arch-test/|" \
		<arch-test >$(DESTDIR)$(PREFIX)/bin/arch-test
	chmod a+x $(DESTDIR)$(PREFIX)/bin/arch-test
	for x in $(ARCHS); do cp -p arch-test-$$x \
		$(DESTDIR)$(PREFIX)/lib/arch-test/$$x;done
	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1/
	install -p *.1 $(DESTDIR)$(PREFIX)/share/man/man1/

arch-test-amd64: amd64.s
	$(X86)-as --64 $^ -o amd64.o
	$(X86)-ld -melf_x86_64 -s amd64.o -o $@

arch-test-x32: x32.s
	$(X86)-as --x32 $^ -o x32.o
	$(X86)-ld -melf32_x86_64 -s x32.o -o $@

arch-test-i386: i386.s
	$(X86)-as --32 $^ -o i386.o
	$(X86)-ld -melf_i386 -s i386.o -o $@

arch-test-win32: generic.c
	i686-w64-mingw32-gcc $^ -s -o $@

arch-test-win64: generic.c
	x86_64-w64-mingw32-gcc $^ -s -o $@

arch-test-mips: mips.s
	$(MIPS)-as -32 -EB $^ -o mips.o
	$(MIPS)-ld -melf32btsmip -s mips.o -o $@

arch-test-mipsel: mips.s
	$(MIPS)-as -32 -EL $^ -o mipsel.o
	$(MIPS)-ld -melf32ltsmip -s mipsel.o -o $@

arch-test-mips64: mips64.s
	$(MIPS)-as -64 -EB $^ -o mips64.o
	$(MIPS)-ld -melf64btsmip -s mips64.o -o $@

arch-test-mips64el: mips64.s
	$(MIPS)-as -64 -EL $^ -o mips64el.o
	$(MIPS)-ld -melf64ltsmip -s mips64el.o -o $@

arch-test-illumos-amd64: solaris-amd64.s
	$(X86)-as --64 $^ -o illumos-amd64.o
	$(X86)-ld -melf_x86_64 -s illumos-amd64.o -o $@

arch-test-kfreebsd-amd64: solaris-amd64.s
	$(X86)-as --64 $^ -o kfreebsd-amd64.o
	$(X86)-ld -melf_x86_64 -s kfreebsd-amd64.o -o $@
	printf '\t'|dd of=$@ bs=1 count=1 seek=7 conv=notrunc

arch-test-kfreebsd-i386: kfreebsd-i386.s
	$(X86)-as --32 $^ -o kfreebsd-i386.o
	$(X86)-ld -melf_i386 -s kfreebsd-i386.o -o $@
	printf '\t'|dd of=$@ bs=1 count=1 seek=7 conv=notrunc

arch-test-powerpc: powerpc.s
	$(POWERPC)-as -a32 $^ -o powerpc.o
	$(POWERPC)-ld -melf32ppc -s powerpc.o -o $@

arch-test-ppc64: ppc64.s
	$(POWERPC)-as -a64 $^ -o ppc64.o
	$(POWERPC)-ld -melf64ppc -s ppc64.o -o $@

arch-test-ppc64el: ppc64el.s
	powerpc64le-linux-gnu-as -mpower8 $^ -o ppc64el.o
	powerpc64le-linux-gnu-ld -s ppc64el.o -o $@

arch-test-powerpcspe: powerpcspe.s
	$(POWERPC)-as -a32 -me500 $^ -o powerpcspe.o
	$(POWERPC)-ld -melf32ppc -s powerpcspe.o -o $@

arch-test-s390x: s390x.s
	s390x-linux-gnu-as $^ -o s390x.o
	s390x-linux-gnu-ld -s s390x.o -o $@

arch-test-arm64: arm64.s
	aarch64-linux-gnu-as $^ -o arm64.o
	aarch64-linux-gnu-ld -s arm64.o -o $@

arch-test-arm: arm.oabi.s
	$(ARM)-as $^ -o arm.o
	$(ARM)-ld -s arm.o -o $@

arch-test-armel: arm.eabi.s
	$(ARM)-as $^ -o armel.o
	$(ARM)-ld -s armel.o -o $@

arch-test-armhf: armhf.s
	$(ARM)-as $^ -o armhf.o
	$(ARM)-ld -s armhf.o -o $@

arch-test-sh4: sh4.s
	sh4-linux-gnu-as $^ -o sh4.o
	sh4-linux-gnu-ld -s sh4.o -o $@

arch-test-m68k: m68k.s
	m68k-linux-gnu-as $^ -o m68k.o
	m68k-linux-gnu-ld -s m68k.o -o $@

arch-test-sparc64: sparc64.s
	$(SPARC)-as --64 $^ -o sparc64.o
	$(SPARC)-ld -melf64_sparc -s sparc64.o -o $@

arch-test-sparc: sparc.s
	$(SPARC)-as --32 $^ -o sparc.o
	$(SPARC)-ld -melf32_sparc -s sparc.o -o $@

arch-test-alpha: alpha.s
	alpha-linux-gnu-as $^ -o alpha.o
	alpha-linux-gnu-ld -s alpha.o -o $@

=== debian/changelog ===
arch-test (0.5-1) unstable; urgency=medium

  * New upstream release (+powerpcspe).
    + don't detect SPE as powerpc

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 14 Jun 2016 03:32:08 +0200

arch-test (0.4-1) unstable; urgency=medium

  * New upstream release (+alpha).
    + require 686 on any-i386
  * NMU instructions in debian/control.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 16 May 2016 05:02:06 +0200

arch-test (0.3-1) unstable; urgency=medium

  * New upstream release (+kfreebsd-i386, kfreebsd-amd64).
  * Use multilib where available to avoid broken binutils-x86-64-linux-gnu
    on i386.
  * Allow dropping archs by removing them from build-depends.
  * Add a watch file.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 17 Apr 2016 19:33:47 +0200

arch-test (0.2-1) unstable; urgency=medium

  * Initial release (Closes: #819207)

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 11 Apr 2016 21:08:00 +0200

=== debian/control ===
Source: arch-test
Section: admin
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper (>=9),
 binutils-x86-64-linux-gnu [!amd64 !i386 !x32],
 binutils-aarch64-linux-gnu [!arm64],
 binutils-arm-linux-gnueabihf [!armhf !armel !arm],
 binutils-m68k-linux-gnu [!m68k],
 binutils-mips-linux-gnu [!mips !mipsel !mips64 !mips64el],
 binutils-powerpc-linux-gnu [!powerpc !ppc64],
 binutils-powerpc64le-linux-gnu [!ppc64el],
 binutils-s390x-linux-gnu [!s390x],
 binutils-sh4-linux-gnu [!sh4],
 binutils-sparc64-linux-gnu [!sparc64 !sparc],
 binutils-alpha-linux-gnu [!alpha],
 mingw-w64
# doko, others: if you want to drop some crap architecture from binutils, feel
# free to shout at me or NMU arch-test to remove it yourself.  It is enough to
# remove from Build-Depends, configure will do the right thing.
Standards-Version: 3.9.8
Vcs-Git: https://github.com/kilobyte/arch-test.git -b debian
Vcs-Browser: https://github.com/kilobyte/arch-test/tree/debian

Package: arch-test
Architecture: all
Depends: ${misc:Depends}
Description: detect architectures supported by your machine/kernel
 This package lets you enumerate architectures that your kernel can run.
 The check is for the ability to run machine code and supporting appropriate
 syscall ABI -- you may need to install userland libraries in a chroot,
 container or via multiarch to actually execute non-static binaries of such
 architectures.
 .
 Architectures detected by this version of arch-test are:
  * amd64, i386, x32
  * mips, mipsel, mips64, mips64el
  * arm, armel, armhf, arm64
  * powerpc, ppc64, ppc64el, powerpcspe
  * m68k
  * sh4
  * s390x
  * sparc, sparc64
  * illumos-amd64
  * win32, win64
  * kfreebsd-amd64, kfreebsd-i386
  * alpha

## arch-test 0.7

=== Makefile ===
--- 
+++ 
@@ -1,15 +1,18 @@
 ARCHS=amd64 x32 i386 \
 	win32 win64 \
-	mips mipsel mips64 mips64el \
+	mips mipsel mipsn32 mipsn32el mips64 mips64el \
 	illumos-amd64 \
 	kfreebsd-amd64 kfreebsd-i386 \
 	powerpc ppc64 ppc64el powerpcspe \
 	s390x \
-	arm64 arm armel armhf \
+	arm64 arm64ilp32 \
+	arm armel armhf \
 	sh4 \
 	m68k \
 	sparc sparc64 \
-	alpha
+	alpha \
+	hppa \
+
 X86=x86_64-linux-gnu
 MIPS=mips-linux-gnu
 POWERPC=powerpc-linux-gnu
@@ -62,6 +65,14 @@
 	$(MIPS)-as -32 -EL $^ -o mipsel.o
 	$(MIPS)-ld -melf32ltsmip -s mipsel.o -o $@
 
+arch-test-mipsn32: mipsn32.s
+	$(MIPS)-as -n32 -EB $^ -o mipsn32.o
+	$(MIPS)-ld -melf32btsmipn32 -s mipsn32.o -o $@
+
+arch-test-mipsn32el: mipsn32.s
+	$(MIPS)-as -n32 -EL $^ -o mipsn32el.o
+	$(MIPS)-ld -melf32ltsmipn32 -s mipsn32el.o -o $@
+
 arch-test-mips64: mips64.s
 	$(MIPS)-as -64 -EB $^ -o mips64.o
 	$(MIPS)-ld -melf64btsmip -s mips64.o -o $@
@@ -108,6 +119,10 @@
 	aarch64-linux-gnu-as $^ -o arm64.o
 	aarch64-linux-gnu-ld -s arm64.o -o $@
 
+arch-test-arm64ilp32: arm64.s
+	aarch64-linux-gnu-as -mabi=ilp32 $^ -o arm64ilp32.o
+	aarch64-linux-gnu-ld -maarch64linux32 -s arm64ilp32.o -o $@
+
 arch-test-arm: arm.oabi.s
 	$(ARM)-as $^ -o arm.o
 	$(ARM)-ld -s arm.o -o $@
@@ -139,3 +154,7 @@
 arch-test-alpha: alpha.s
 	alpha-linux-gnu-as $^ -o alpha.o
 	alpha-linux-gnu-ld -s alpha.o -o $@
+
+arch-test-hppa: hppa.s
+	hppa-linux-gnu-as $^ -o hppa.o
+	hppa-linux-gnu-ld -s hppa.o -o $@

=== debian/changelog ===
arch-test (0.7-1) unstable; urgency=medium

  * New upstream release (+hppa).
    + check whether SWP works on armel
  * Multi-Arch: foreign.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 06 Dec 2016 05:08:22 +0100

arch-test (0.6-1) unstable; urgency=medium

  * New upstream release (+mipsn32, mipsn32el, arm64ilp32).
    + new option "-n" to look for native support only

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 18 Oct 2016 04:12:27 +0200

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
  binutils-sh4-linux-gnu [!sh4],
  binutils-sparc64-linux-gnu [!sparc64 !sparc],
  binutils-alpha-linux-gnu [!alpha],
+ binutils-hppa-linux-gnu [!hppa],
  mingw-w64
 # doko, others: if you want to drop some crap architecture from binutils, feel
 # free to shout at me or NMU arch-test to remove it yourself.  It is enough to
@@ -24,6 +25,7 @@
 
 Package: arch-test
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: detect architectures supported by your machine/kernel
  This package lets you enumerate architectures that your kernel can run.
@@ -35,7 +37,7 @@
  Architectures detected by this version of arch-test are:
   * amd64, i386, x32
   * mips, mipsel, mips64, mips64el
-  * arm, armel, armhf, arm64
+  * arm, armel, armhf, arm64, arm64ilp32
   * powerpc, ppc64, ppc64el, powerpcspe
   * m68k
   * sh4
@@ -45,3 +47,4 @@
   * win32, win64
   * kfreebsd-amd64, kfreebsd-i386
   * alpha
+  * hppa

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


%:
	dh $@ --parallel

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/arch-test/ PREFIX=/usr

=== debian/watch ===
version=2
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/arch-test-$1\.tar\.gz/ \
  https://github.com/kilobyte/arch-test/tags .*/v?(\d\S*)\.tar\.gz

## arch-test 0.10

=== Makefile ===
--- 
+++ 
@@ -12,6 +12,8 @@
 	sparc sparc64 \
 	alpha \
 	hppa \
+	ia64 \
+	riscv64 \
 
 X86=x86_64-linux-gnu
 MIPS=mips-linux-gnu
@@ -51,11 +53,13 @@
 	$(X86)-as --32 $^ -o i386.o
 	$(X86)-ld -melf_i386 -s i386.o -o $@
 
-arch-test-win32: generic.c
-	i686-w64-mingw32-gcc $^ -s -o $@
+arch-test-win32: win32.s
+	i686-w64-mingw32-as $^ -o win32.o
+	i686-w64-mingw32-ld -s win32.o -lkernel32 -o $@
 
-arch-test-win64: generic.c
-	x86_64-w64-mingw32-gcc $^ -s -o $@
+arch-test-win64: win64.s
+	x86_64-w64-mingw32-as $^ -o win64.o
+	x86_64-w64-mingw32-ld -s win64.o -lkernel32 -o $@
 
 arch-test-mips: mips.s
 	$(MIPS)-as -32 -EB $^ -o mips.o
@@ -85,14 +89,17 @@
 	$(X86)-as --64 $^ -o illumos-amd64.o
 	$(X86)-ld -melf_x86_64 -s illumos-amd64.o -o $@
 
+# same ABI as Solaris, save for branding.
 arch-test-kfreebsd-amd64: solaris-amd64.s
 	$(X86)-as --64 $^ -o kfreebsd-amd64.o
 	$(X86)-ld -melf_x86_64 -s kfreebsd-amd64.o -o $@
+	# FreeBSD relies on "branding" of ELF files.
 	printf '\t'|dd of=$@ bs=1 count=1 seek=7 conv=notrunc
 
 arch-test-kfreebsd-i386: kfreebsd-i386.s
 	$(X86)-as --32 $^ -o kfreebsd-i386.o
 	$(X86)-ld -melf_i386 -s kfreebsd-i386.o -o $@
+	# FreeBSD relies on "branding" of ELF files.
 	printf '\t'|dd of=$@ bs=1 count=1 seek=7 conv=notrunc
 
 arch-test-powerpc: powerpc.s
@@ -127,7 +134,7 @@
 	$(ARM)-as $^ -o arm.o
 	$(ARM)-ld -s arm.o -o $@
 
-arch-test-armel: arm.eabi.s
+arch-test-armel: armel.s
 	$(ARM)-as $^ -o armel.o
 	$(ARM)-ld -s armel.o -o $@
 
@@ -158,3 +165,11 @@
 arch-test-hppa: hppa.s
 	hppa-linux-gnu-as $^ -o hppa.o
 	hppa-linux-gnu-ld -s hppa.o -o $@
+
+arch-test-ia64: ia64.s
+	ia64-linux-gnu-as $^ -o ia64.o
+	ia64-linux-gnu-ld -s ia64.o -o $@
+
+arch-test-riscv64: riscv64.s
+	riscv64-linux-gnu-as $^ -o riscv64.o
+	riscv64-linux-gnu-ld -s riscv64.o -o $@

=== debian/changelog ===
arch-test (0.10-1) unstable; urgency=medium

  * New upstream release (+riscv64).
  * Actually add R³.
  * watch: ignore debian tags.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 25 Feb 2018 02:43:03 +0100

arch-test (0.9-1) unstable; urgency=medium

  * New upstream release.
  * Build-Depend only on Windows binutils and headers.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 10 Jan 2018 00:55:03 +0100

arch-test (0.8-1) unstable; urgency=medium

  * New upstream release (+ia64).
  * dh 11.
  * R³.
  * Override lintian warning for non-hardened Windows binary.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 09 Jan 2018 14:27:24 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper (>=9),
+Build-Depends: debhelper (>=11),
  binutils-x86-64-linux-gnu [!amd64 !i386 !x32],
  binutils-aarch64-linux-gnu [!arm64],
  binutils-arm-linux-gnueabihf [!armhf !armel !arm],
@@ -15,11 +15,15 @@
  binutils-sparc64-linux-gnu [!sparc64 !sparc],
  binutils-alpha-linux-gnu [!alpha],
  binutils-hppa-linux-gnu [!hppa],
- mingw-w64
+ binutils-ia64-linux-gnu [!ia64],
+ binutils-riscv64-linux-gnu [!riscv64],
+ binutils-mingw-w64-i686, mingw-w64-i686-dev,
+ binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
 # doko, others: if you want to drop some crap architecture from binutils, feel
 # free to shout at me or NMU arch-test to remove it yourself.  It is enough to
 # remove from Build-Depends, configure will do the right thing.
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
+Rules-Requires-Root: no
 Vcs-Git: https://github.com/kilobyte/arch-test.git -b debian
 Vcs-Browser: https://github.com/kilobyte/arch-test/tree/debian
 
@@ -48,3 +52,5 @@
   * kfreebsd-amd64, kfreebsd-i386
   * alpha
   * hppa
+  * ia64
+  * riscv64

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_install:
 	$(MAKE) install DESTDIR=$(CURDIR)/debian/arch-test/ PREFIX=/usr

## arch-test 0.12

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+VERSION=$(shell git describe)
 ARCHS=amd64 x32 i386 \
 	win32 win64 \
 	mips mipsel mipsn32 mipsn32el mips64 mips64el \
@@ -32,8 +33,9 @@
 DESTDIR=
 PREFIX=/usr/local
 install: all
+	mkdir -p $(DESTDIR)$(PREFIX)/bin
 	mkdir -p $(DESTDIR)$(PREFIX)/lib/arch-test/
-	sed -e "s|^HELPERS.*|HELPERS=$(PREFIX)/lib/arch-test/|" \
+	sed -e "s|^HELPERS.*|HELPERS=$(PREFIX)/lib/arch-test/|;s&..git describe.&$(VERSION)&" \
 		<arch-test >$(DESTDIR)$(PREFIX)/bin/arch-test
 	chmod a+x $(DESTDIR)$(PREFIX)/bin/arch-test
 	for x in $(ARCHS); do cp -p arch-test-$$x \

=== debian/changelog ===
arch-test (0.12-2) unstable; urgency=medium

  * Fix --version when built without git available.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 05 May 2018 01:15:24 +0200

arch-test (0.12-1) unstable; urgency=medium

  * New upstream release.
    + add --version (Closes: #897615)
  * A simple autopkgtest: check whether dpkg's architecture is executable.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 04 May 2018 23:38:10 +0200

arch-test (0.11-1) unstable; urgency=medium

  * New upstream release (-c <chroot>).
  * Build-Conflict against a problematic version of binutils-mingw.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 02 Apr 2018 20:25:21 +0200

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 # doko, others: if you want to drop some crap architecture from binutils, feel
 # free to shout at me or NMU arch-test to remove it yourself.  It is enough to
 # remove from Build-Depends, configure will do the right thing.
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Rules-Requires-Root: no
 Vcs-Git: https://github.com/kilobyte/arch-test.git -b debian
 Vcs-Browser: https://github.com/kilobyte/arch-test/tree/debian

## arch-test 0.13

=== debian/changelog ===
arch-test (0.13-1) unstable; urgency=medium

  * New upstream release (adds "elf-arch").  Closes: #905959.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 11 Oct 2018 20:20:08 +0200

## arch-test 0.14

=== debian/changelog ===
arch-test (0.14-1) unstable; urgency=medium

  * New upstream release.
    + elf-arch: recognition of mips{,64}r6{,el}.  Closes: #910981.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 14 Oct 2018 15:58:47 +0200

## arch-test 0.15

=== debian/changelog ===
arch-test (0.15-2+deb10u1) buster; urgency=medium

  * Fix s390x detection sometimes failing (Alexander Efremkin).

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 16 Aug 2020 15:25:50 +0200

arch-test (0.15-2) unstable; urgency=medium

  * Don't check for SWP on armel; it's not needed in the vast majority of
    cases anymore.  Yes, you'll get crashes if it's actually used.
    Closes: #922728.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 27 Feb 2019 13:41:50 +0100

arch-test (0.15-1) unstable; urgency=medium

  * New upstream release.
    + elf-arch knows about hppa64 (closes: #912369) and strips OS/libc
      prefixes it can't properly detect, such as hurd- or musl-linux-
      (closes: #911156, #912368).

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 31 Oct 2018 00:53:04 +0100

=== debian/tests/control ===
Tests: dpkg-arch-works

## arch-test 0.16

=== debian/changelog ===
arch-test (0.16-2) unstable; urgency=medium

  * Build mips{,64}{,el} tests on mips64el ("mips" is no more).
  * Drop an unused lintian override.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 22 Aug 2019 23:22:14 +0200

arch-test (0.16-1) unstable; urgency=medium

  * New upstream release.
    + Fix false negatives on s390x due to uninitialized register upper half
      (Alexander Efremkin).
  * Add a test that no-args invocation doesn't spew errors on failed archs.
  * dh 12.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 27 Jul 2019 02:25:41 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: admin
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper (>=11),
+Build-Depends: debhelper-compat (=12),
  binutils-x86-64-linux-gnu [!amd64 !i386 !x32],
  binutils-aarch64-linux-gnu [!arm64],
  binutils-arm-linux-gnueabihf [!armhf !armel !arm],
  binutils-m68k-linux-gnu [!m68k],
- binutils-mips-linux-gnu [!mips !mipsel !mips64 !mips64el],
+ binutils-mips64el-linux-gnuabi64 [!mips !mipsel !mips64 !mips64el],
  binutils-powerpc-linux-gnu [!powerpc !ppc64],
  binutils-powerpc64le-linux-gnu [!ppc64el],
  binutils-s390x-linux-gnu [!s390x],
@@ -19,10 +19,10 @@
  binutils-riscv64-linux-gnu [!riscv64],
  binutils-mingw-w64-i686, mingw-w64-i686-dev,
  binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
-# doko, others: if you want to drop some crap architecture from binutils, feel
-# free to shout at me or NMU arch-test to remove it yourself.  It is enough to
-# remove from Build-Depends, configure will do the right thing.
-Standards-Version: 4.1.4
+# doko, others: if you want to drop an architecture from binutils, feel
+# free to shout at me or NMU arch-test to remove it yourself.  It is
+# enough to remove from Build-Depends, configure will do the right thing.
+Standards-Version: 4.4.0
 Rules-Requires-Root: no
 Vcs-Git: https://github.com/kilobyte/arch-test.git -b debian
 Vcs-Browser: https://github.com/kilobyte/arch-test/tree/debian
@@ -37,6 +37,9 @@
  syscall ABI -- you may need to install userland libraries in a chroot,
  container or via multiarch to actually execute non-static binaries of such
  architectures.
+ .
+ Also provided is "elf-arch", a tool to determine the architecture of an ELF
+ binary (program or library).
  .
  Architectures detected by this version of arch-test are:
   * amd64, i386, x32

=== debian/watch ===
version=2
opts=filenamemangle=s/.+\/v(\d\S*)\.tar\.gz/arch-test-$1\.tar\.gz/ \
  https://github.com/kilobyte/arch-test/tags .*/v(\d\S*)\.tar\.gz

## arch-test 0.17

=== Makefile ===
--- 
+++ 
@@ -42,6 +42,7 @@
 		$(DESTDIR)$(PREFIX)/lib/arch-test/$$x;done
 	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1/
 	install -p *.1 $(DESTDIR)$(PREFIX)/share/man/man1/
+	install -p elf-arch $(DESTDIR)$(PREFIX)/bin/
 
 arch-test-amd64: amd64.s
 	$(X86)-as --64 $^ -o amd64.o

=== debian/changelog ===
arch-test (0.17-2) unstable; urgency=medium

  * Temporarily disable win64 (binutils issue); closes: #998593.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 16 Nov 2021 13:05:14 +0100

arch-test (0.17-1) unstable; urgency=medium

  * New upstream release.
    + man page doesn't claim qemu requires copying stuff to chroot.
      Closes: #939910.
  * Bump watch file version to 4 (no changes).

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 21 Jan 2021 01:31:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper-compat (=12),
+Build-Depends: debhelper-compat (=13),
  binutils-x86-64-linux-gnu [!amd64 !i386 !x32],
  binutils-aarch64-linux-gnu [!arm64],
  binutils-arm-linux-gnueabihf [!armhf !armel !arm],
@@ -18,11 +18,11 @@
  binutils-ia64-linux-gnu [!ia64],
  binutils-riscv64-linux-gnu [!riscv64],
  binutils-mingw-w64-i686, mingw-w64-i686-dev,
- binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
+#binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
 # doko, others: if you want to drop an architecture from binutils, feel
 # free to shout at me or NMU arch-test to remove it yourself.  It is
 # enough to remove from Build-Depends, configure will do the right thing.
-Standards-Version: 4.4.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://github.com/kilobyte/arch-test.git -b debian
 Vcs-Browser: https://github.com/kilobyte/arch-test/tree/debian

## arch-test 0.18

=== Makefile ===
VERSION=$(shell git describe)
ARCHS=amd64 x32 i386 \
	win32 win64 \
	mips mipsel mipsn32 mipsn32el mips64 mips64el \
	illumos-amd64 \
	kfreebsd-amd64 kfreebsd-i386 \
	powerpc ppc64 ppc64el powerpcspe \
	s390x \
	arm64 arm64ilp32 \
	arm armel armhf \
	sh4 \
	m68k \
	sparc sparc64 \
	alpha \
	hppa \
	ia64 \
	riscv64 \

X86=x86_64-linux-gnu
MIPS=mips-linux-gnu
POWERPC=powerpc-linux-gnu
ARM=arm-linux-gnueabihf
SPARC=sparc64-linux-gnu
-include config
all: $(ARCHS:%=arch-test-%)

clean:
	rm -f *.o arch-test-* core *.core

distclean: clean
	rm -f config

DESTDIR=
PREFIX=/usr/local
install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	mkdir -p $(DESTDIR)$(PREFIX)/lib/arch-test/
	sed -e "s|^HELPERS.*|HELPERS=$(PREFIX)/lib/arch-test/|;s&..git describe.&$(VERSION)&" \
		<arch-test >$(DESTDIR)$(PREFIX)/bin/arch-test
	chmod a+x $(DESTDIR)$(PREFIX)/bin/arch-test
	for x in $(ARCHS); do cp -p arch-test-$$x \
		$(DESTDIR)$(PREFIX)/lib/arch-test/$$x;done
	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1/
	install -p *.1 $(DESTDIR)$(PREFIX)/share/man/man1/
	install -p elf-arch $(DESTDIR)$(PREFIX)/bin/

arch-test-amd64: amd64.s
	$(X86)-as --64 $^ -o amd64.o
	$(X86)-ld -z noexecstack -melf_x86_64 -s amd64.o -o $@

arch-test-x32: x32.s
	$(X86)-as --x32 $^ -o x32.o
	$(X86)-ld -z noexecstack -melf32_x86_64 -s x32.o -o $@

arch-test-i386: i386.s
	$(X86)-as --32 $^ -o i386.o
	$(X86)-ld -z noexecstack -melf_i386 -s i386.o -o $@

arch-test-win32: win32.s
	i686-w64-mingw32-as $^ -o win32.o
	i686-w64-mingw32-ld -s win32.o -lkernel32 -o $@

arch-test-win64: win64.s
	x86_64-w64-mingw32-as $^ -o win64.o
	x86_64-w64-mingw32-ld -s win64.o -lkernel32 -o $@

arch-test-mips: mips.s
	$(MIPS)-as -32 -EB $^ -o mips.o
	$(MIPS)-ld -z noexecstack -melf32btsmip -s mips.o -o $@

arch-test-mipsel: mips.s
	$(MIPS)-as -32 -EL $^ -o mipsel.o
	$(MIPS)-ld -z noexecstack -melf32ltsmip -s mipsel.o -o $@

arch-test-mipsn32: mipsn32.s
	$(MIPS)-as -n32 -EB $^ -o mipsn32.o
	$(MIPS)-ld -z noexecstack -melf32btsmipn32 -s mipsn32.o -o $@

arch-test-mipsn32el: mipsn32.s
	$(MIPS)-as -n32 -EL $^ -o mipsn32el.o
	$(MIPS)-ld -z noexecstack -melf32ltsmipn32 -s mipsn32el.o -o $@

arch-test-mips64: mips64.s
	$(MIPS)-as -64 -EB $^ -o mips64.o
	$(MIPS)-ld -z noexecstack -melf64btsmip -s mips64.o -o $@

arch-test-mips64el: mips64.s
	$(MIPS)-as -64 -EL $^ -o mips64el.o
	$(MIPS)-ld -z noexecstack -melf64ltsmip -s mips64el.o -o $@

arch-test-illumos-amd64: solaris-amd64.s
	$(X86)-as --64 $^ -o illumos-amd64.o
	$(X86)-ld -z noexecstack -melf_x86_64 -s illumos-amd64.o -o $@

# same ABI as Solaris, save for branding.
arch-test-kfreebsd-amd64: solaris-amd64.s
	$(X86)-as --64 $^ -o kfreebsd-amd64.o
	$(X86)-ld -z noexecstack -melf_x86_64 -s kfreebsd-amd64.o -o $@
	# FreeBSD relies on "branding" of ELF files.
	printf '\t'|dd of=$@ bs=1 count=1 seek=7 conv=notrunc

arch-test-kfreebsd-i386: kfreebsd-i386.s
	$(X86)-as --32 $^ -o kfreebsd-i386.o
	$(X86)-ld -z noexecstack -melf_i386 -s kfreebsd-i386.o -o $@
	# FreeBSD relies on "branding" of ELF files.
	printf '\t'|dd of=$@ bs=1 count=1 seek=7 conv=notrunc

arch-test-powerpc: powerpc.s
	$(POWERPC)-as -a32 $^ -o powerpc.o
	$(POWERPC)-ld -z noexecstack -melf32ppc -s powerpc.o -o $@

arch-test-ppc64: ppc64.s
	$(POWERPC)-as -a64 $^ -o ppc64.o
	$(POWERPC)-ld -z noexecstack -melf64ppc -s ppc64.o -o $@

arch-test-ppc64el: ppc64el.s
	powerpc64le-linux-gnu-as -mpower8 $^ -o ppc64el.o
	powerpc64le-linux-gnu-ld -z noexecstack -s ppc64el.o -o $@

arch-test-powerpcspe: powerpcspe.s
	$(POWERPC)-as -a32 -me500 $^ -o powerpcspe.o
	$(POWERPC)-ld -z noexecstack -melf32ppc -s powerpcspe.o -o $@

arch-test-s390x: s390x.s
	s390x-linux-gnu-as $^ -o s390x.o
	s390x-linux-gnu-ld -z noexecstack -s s390x.o -o $@

arch-test-arm64: arm64.s
	aarch64-linux-gnu-as $^ -o arm64.o
	aarch64-linux-gnu-ld -z noexecstack -s arm64.o -o $@

arch-test-arm64ilp32: arm64.s
	aarch64-linux-gnu-as -mabi=ilp32 $^ -o arm64ilp32.o
	aarch64-linux-gnu-ld -z noexecstack -maarch64linux32 -s arm64ilp32.o -o $@

arch-test-arm: arm.oabi.s
	$(ARM)-as $^ -o arm.o
	$(ARM)-ld -z noexecstack -s arm.o -o $@

arch-test-armel: armel.s
	$(ARM)-as $^ -o armel.o
	$(ARM)-ld -z noexecstack -s armel.o -o $@

arch-test-armhf: armhf.s
	$(ARM)-as $^ -o armhf.o
	$(ARM)-ld -z noexecstack -s armhf.o -o $@

arch-test-sh4: sh4.s
	sh4-linux-gnu-as $^ -o sh4.o
	sh4-linux-gnu-ld -z noexecstack -s sh4.o -o $@

arch-test-m68k: m68k.s
	m68k-linux-gnu-as $^ -o m68k.o
	m68k-linux-gnu-ld -z noexecstack -s m68k.o -o $@

arch-test-sparc64: sparc64.s
	$(SPARC)-as --64 $^ -o sparc64.o
	$(SPARC)-ld -z noexecstack -melf64_sparc -s sparc64.o -o $@

arch-test-sparc: sparc.s
	$(SPARC)-as --32 $^ -o sparc.o
	$(SPARC)-ld -z noexecstack -melf32_sparc -s sparc.o -o $@

arch-test-alpha: alpha.s
	alpha-linux-gnu-as $^ -o alpha.o
	alpha-linux-gnu-ld -z noexecstack -s alpha.o -o $@

arch-test-hppa: hppa.s
	hppa-linux-gnu-as $^ -o hppa.o
	hppa-linux-gnu-ld -z noexecstack -s hppa.o -o $@

arch-test-ia64: ia64.s
	ia64-linux-gnu-as $^ -o ia64.o
	ia64-linux-gnu-ld -z noexecstack -s ia64.o -o $@

arch-test-riscv64: riscv64.s
	riscv64-linux-gnu-as $^ -o riscv64.o
	riscv64-linux-gnu-ld -z noexecstack -s riscv64.o -o $@

=== debian/changelog ===
arch-test (0.18-1) unstable; urgency=medium

  * New upstream release.
    + Fixes a dmesg warning about executable stack.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 24 Mar 2022 21:06:22 +0100

## arch-test 0.19

=== debian/changelog ===
arch-test (0.19-1) unstable; urgency=medium

  * New upstream release.
  * Re-enable win64, fixed.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 10 Sep 2022 23:20:17 +0200

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,11 @@
  binutils-ia64-linux-gnu [!ia64],
  binutils-riscv64-linux-gnu [!riscv64],
  binutils-mingw-w64-i686, mingw-w64-i686-dev,
-#binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
+ binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
 # doko, others: if you want to drop an architecture from binutils, feel
 # free to shout at me or NMU arch-test to remove it yourself.  It is
 # enough to remove from Build-Depends, configure will do the right thing.
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://github.com/kilobyte/arch-test.git -b debian
 Vcs-Browser: https://github.com/kilobyte/arch-test/tree/debian

## arch-test 0.20

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,8 @@
 	hppa \
 	ia64 \
 	riscv64 \
+	loong64 \
+	arc \
 
 X86=x86_64-linux-gnu
 MIPS=mips-linux-gnu
@@ -176,3 +178,11 @@
 arch-test-riscv64: riscv64.s
 	riscv64-linux-gnu-as $^ -o riscv64.o
 	riscv64-linux-gnu-ld -z noexecstack -s riscv64.o -o $@
+
+arch-test-loong64: loong64.s
+	loongarch64-linux-gnu-as $^ -o loong64.o
+	loongarch64-linux-gnu-ld -z noexecstack -s loong64.o -o $@
+
+arch-test-arc: arc.s
+	arc-linux-gnu-as $^ -o arc.o
+	arc-linux-gnu-ld -z noexecstack -s arc.o -o $@

=== debian/changelog ===
arch-test (0.20-1) unstable; urgency=medium

  * New upstream release (+arc, [not enabled] loong64).
  * No loong64 because we don't have a binutils package yet.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 09 Jan 2023 22:33:12 +0100

## arch-test 0.21

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	alpha \
 	hppa \
 	ia64 \
-	riscv64 \
+	riscv32 riscv64 \
 	loong64 \
 	arc \
 
@@ -186,3 +186,7 @@
 arch-test-arc: arc.s
 	arc-linux-gnu-as $^ -o arc.o
 	arc-linux-gnu-ld -z noexecstack -s arc.o -o $@
+
+arch-test-riscv32: riscv32.s
+	riscv32-linux-gnu-as $^ -o riscv32.o
+	riscv32-linux-gnu-ld -z noexecstack -s riscv32.o -o $@

=== debian/changelog ===
arch-test (0.21-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove ia64 support. (Closes: #1089980)
    - Binutils has dropped binutils-ia64-linux-gnu.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 19 Dec 2024 19:55:53 +0000

arch-test (0.21-1) unstable; urgency=medium

  * New upstream release.
  * No riscv32 because no binutils in Debian.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 07 Jul 2023 07:34:05 +0200

=== debian/control ===
--- 
+++ 
@@ -15,14 +15,15 @@
  binutils-sparc64-linux-gnu [!sparc64 !sparc],
  binutils-alpha-linux-gnu [!alpha],
  binutils-hppa-linux-gnu [!hppa],
- binutils-ia64-linux-gnu [!ia64],
  binutils-riscv64-linux-gnu [!riscv64],
+#binutils-loong64-linux-gnu [!loong64],
+ binutils-arc-linux-gnu [!arc],
  binutils-mingw-w64-i686, mingw-w64-i686-dev,
  binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
 # doko, others: if you want to drop an architecture from binutils, feel
 # free to shout at me or NMU arch-test to remove it yourself.  It is
 # enough to remove from Build-Depends, configure will do the right thing.
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://github.com/kilobyte/arch-test.git -b debian
 Vcs-Browser: https://github.com/kilobyte/arch-test/tree/debian
@@ -55,5 +56,5 @@
   * kfreebsd-amd64, kfreebsd-i386
   * alpha
   * hppa
-  * ia64
   * riscv64
+  * arc

=== debian/rules ===
--- 
+++ 
@@ -7,4 +7,5 @@
 	dh $@
 
 override_dh_auto_install:
-	$(MAKE) install DESTDIR=$(CURDIR)/debian/arch-test/ PREFIX=/usr
+	$(MAKE) install DESTDIR=$(CURDIR)/debian/arch-test/ PREFIX=/usr \
+	    VERSION=v$(shell dpkg-parsechangelog -S Version|cut -d- -f1)

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v(\d\S*)\.tar\.gz/arch-test-$1\.tar\.gz/ \
  https://github.com/kilobyte/arch-test/tags .*/v(\d\S*)\.tar\.gz

## arch-test 0.22

=== Makefile ===
--- 
+++ 
@@ -36,12 +36,12 @@
 PREFIX=/usr/local
 install: all
 	mkdir -p $(DESTDIR)$(PREFIX)/bin
-	mkdir -p $(DESTDIR)$(PREFIX)/lib/arch-test/
-	sed -e "s|^HELPERS.*|HELPERS=$(PREFIX)/lib/arch-test/|;s&..git describe.&$(VERSION)&" \
+	mkdir -p $(DESTDIR)$(PREFIX)/libexec/arch-test/
+	sed -e "s|^HELPERS.*|HELPERS=$(PREFIX)/libexec/arch-test/|;s&..git describe.&$(VERSION)&" \
 		<arch-test >$(DESTDIR)$(PREFIX)/bin/arch-test
 	chmod a+x $(DESTDIR)$(PREFIX)/bin/arch-test
 	for x in $(ARCHS); do cp -p arch-test-$$x \
-		$(DESTDIR)$(PREFIX)/lib/arch-test/$$x;done
+		$(DESTDIR)$(PREFIX)/libexec/arch-test/$$x;done
 	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1/
 	install -p *.1 $(DESTDIR)$(PREFIX)/share/man/man1/
 	install -p elf-arch $(DESTDIR)$(PREFIX)/bin/
@@ -176,8 +176,8 @@
 	ia64-linux-gnu-ld -z noexecstack -s ia64.o -o $@
 
 arch-test-riscv64: riscv64.s
-	riscv64-linux-gnu-as $^ -o riscv64.o
-	riscv64-linux-gnu-ld -z noexecstack -s riscv64.o -o $@
+	$(RISCV)-as --march=rv64g $^ -o riscv64.o
+	$(RISCV)-ld -z noexecstack -m elf64lriscv -s riscv64.o -o $@
 
 arch-test-loong64: loong64.s
 	loongarch64-linux-gnu-as $^ -o loong64.o
@@ -188,5 +188,5 @@
 	arc-linux-gnu-ld -z noexecstack -s arc.o -o $@
 
 arch-test-riscv32: riscv32.s
-	riscv32-linux-gnu-as $^ -o riscv32.o
-	riscv32-linux-gnu-ld -z noexecstack -s riscv32.o -o $@
+	$(RISCV)-as --march=rv32g $^ -o riscv32.o
+	$(RISCV)-ld -z noexecstack -m elf32lriscv -s riscv32.o -o $@

=== debian/changelog ===
arch-test (0.22-1) unstable; urgency=medium

  * New upstream release.
    + can cross riscv32 using riscv64 binutils.
    + installs into libexec not lib
  * Enable loong64, we have binutils now; closes: #1099639.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 10 Mar 2025 05:21:30 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  binutils-alpha-linux-gnu [!alpha],
  binutils-hppa-linux-gnu [!hppa],
  binutils-riscv64-linux-gnu [!riscv64],
-#binutils-loong64-linux-gnu [!loong64],
+ binutils-loongarch64-linux-gnu [!loong64],
  binutils-arc-linux-gnu [!arc],
  binutils-mingw-w64-i686, mingw-w64-i686-dev,
  binutils-mingw-w64-x86-64, mingw-w64-x86-64-dev,
@@ -56,5 +56,6 @@
   * kfreebsd-amd64, kfreebsd-i386
   * alpha
   * hppa
-  * riscv64
+  * riscv64, riscv32
   * arc
+  * loong64
